More CA handling needed
[strace-test.git] / strace-build-test
1 #!/bin/bash
2
3 POINT=HEAD
4 ARCH=$(dpkg-architecture -q DEB_BUILD_ARCH)
5 HOSTNAME=$(hostname)
6 PKG_TEST="https://www.einval.com/debian/strace/package-test"
7
8 while getopts ":p:a:" opt; do
9   case $opt in
10     p)
11       POINT=$OPTARG
12       ;;
13     a)
14       ARCH=$OPTARG
15       set +e
16       chk=`dpkg-architecture -a$ARCH > /dev/null 2>&1 ; echo $?`
17       set -e
18       if [ $chk != 0 ]; then
19           echo "Did not recognise ${ARCH} as a Debian architecture name. Exit."
20           exit 1
21       fi
22       ARCH=${ARCH}
23       ;;
24     \?)
25       echo "Invalid option: -$OPTARG" >&2
26       ;;
27   esac
28 done
29
30 PATH=/usr/local/sbin:/usr/local/bin:$PATH
31 export PATH
32
33 NUMCPUS=$(grep processor /proc/cpuinfo | wc -l)
34 if [ $NUMCPUS -gt 1 ]; then
35     PARALLEL="-j $NUMCPUS"
36 else
37     PARALLEL=""
38 fi
39
40 set -e
41 set -x
42
43 mysid=sid-93sam-strace-$RANDOM
44
45 BASE_CHROOT="sid_$ARCH-dchroot"
46
47 schroot -e -c $mysid || true
48 schroot -b -c $BASE_CHROOT -n $mysid
49 dd-schroot-cmd -y -c $mysid apt-get update
50 dd-schroot-cmd -y -c $mysid apt-get build-dep strace
51 dd-schroot-cmd -y -c $mysid apt-get install git autotools-dev gawk dh-autoreconf
52 dd-schroot-cmd -y -c $mysid apt-get install gcc-multilib || true
53
54 DATETIME=$(date -u '+%Y-%m-%d-%H%M%S')
55 BDIR=~/build/strace/build-test-${DATETIME}
56
57 mkdir -p ${BDIR}
58 cd ${BDIR}
59
60 cat > ~/build/strace/inside-schroot-test.sh << EOF
61 #!/bin/sh
62 cd ${BDIR}
63 git clone -q http://git.code.sf.net/p/strace/code strace.git
64 echo "BUILD ENVIRONMENT INFORMATION"
65 echo "============================="
66 echo "Debian architecture"
67 echo "-------------------"
68 dpkg-architecture -q DEB_BUILD_ARCH
69 echo "Hostname"
70 echo "--------"
71 hostname
72 echo "uname -rm"
73 echo "---------"
74 uname -rm
75 echo "Version of kernel headers (linux-libc-dev)"
76 echo "------------------------------------------"
77 dpkg -s linux-libc-dev
78 echo "Version of libc"
79 echo "---------------"
80 dpkg -s libc6-dev
81 echo "Version of gcc"
82 echo "--------------"
83 dpkg -s gcc
84 cd strace.git
85 git checkout $POINT
86 git log | head -1
87 ./bootstrap
88 ./configure
89 make $PARALLEL && make check VERBOSE=1 && echo SUCCESS > ${BDIR}/RESULT
90 EOF
91
92 chmod +x ~/build/strace/inside-schroot-test.sh
93
94 cd ~
95
96 # Run the command, outout to typescript
97 script -c "schroot -r -c $mysid ~/build/strace/inside-schroot-test.sh"
98
99 if [ ! -f ${BDIR}/RESULT ] ; then
100     echo "BUILD FAILED - not doing cleanup"
101     echo "Results in ${BDIR}"
102 fi
103
104 rm -rf ${BDIR}
105 rm -f ~/build/strace/inside-schroot-test.sh
106 mv typescript typescript-$ARCH-$HOSTNAME-${DATETIME}.txt
107 gzip -9 typescript-$ARCH-$HOSTNAME-${DATETIME}.txt
108 FILE="typescript-$ARCH-$HOSTNAME-${DATETIME}.txt.gz"
109 (echo "START $FILE" ; \
110  base64 < $FILE ; \
111  echo "END $FILE") | \
112     mailx -s "strace-build-test $ARCH-$HOSTNAME-${DATETIME} log" \
113           steve-strace@einval.com
114 rm -f $FILE
115
116 # Check to see if we have a package build to test too, run it in a
117 # separate log file but using the same chroot for speed
118 rm -rf ~/build/strace/package-test
119 set +e
120 wget --ca-certificate=/etc/ssl/ca-global/ca-certificates.crt -O /dev/null $PKG_TEST
121 if [ $? -eq 0 ]; then
122     # Time to grab sources
123     mkdir ~/build/strace/package-test
124     cd ~/build/strace/package-test
125     wget --ca-certificate=/home/93sam/.CA/ca-certificates.crt -r -nd -np $PKG_TEST
126     DSC=$(ls *.dsc)
127
128     cat > ~/build/strace/inside-schroot-test.sh << EOF
129 #!/bin/sh
130 cd ~/build/strace/package-test
131 dpkg-source -x *.dsc
132 cd strace-*
133 debuild
134 EOF
135     chmod +x ~/build/strace/inside-schroot-test.sh
136     set -e
137     cd ~
138     # Run the command, outout to typescript
139     script -c "schroot -r -c $mysid ~/build/strace/inside-schroot-test.sh"
140
141     rm -rf ~/build/strace/package-test
142     rm -f ~/build/strace/inside-schroot-test.sh
143     cat typescript | \
144         mailx -s "$DSC package build log: $ARCH on $HOSTNAME " \
145               steve@einval.com
146     rm -f typescript
147 fi
148
149 schroot -e -c $mysid
150